program gq_borodin

version 10

if $is_changed==0 global a_xsize=5

display
display
display
display as text". BORODIN PLOT, by F. Bea (2008); v. 3.0"
display
display ". THIS IS USEFUL MOSTLY FOR ROCKS WITH ASI<1.05 AND SiO2 < 70 wt.%"
display

/*calculo del numero de grupos y labels diferentes*/
quietly {
capture drop orden
gen orden=_n
sort label
capture drop type
gen type=.
replace type=1 in 1
local n=_N
local ng=1
local t1=label[1]
forvalues i=2(1)`n' {
				local c1=`i'-1
				replace type=`ng' in `i'
				if label[`i']!=label[`c1'] {
					local ng=`ng'+1
					local t`ng'= label[`i']
					replace type=`ng' in `i'
					}
				}	
replace type=6969 if label=="ZZ" /*exclusion del grupo labeled ZZ*/
local mute=0
forvalues i=2(1)`n' {
	if label[`i']=="ZZ" local mute=1
	}
if `mute'==1 local ng=`ng'-1				
sort orden
drop orden
}
/*fin*/

/*crea la leyenda*/
if `ng'==1 local leyenda "2 "`t1'""
if `ng'==2 local leyenda "2 "`t1'" 3 "`t2'""
if `ng'==3 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'""
if `ng'==4 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'""
if `ng'==5 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'" 6 "`t5'""
if `ng'==6 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'" 6 "`t5'" 7 "`t6'""
if `ng'==7 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'" 6 "`t5'" 7 "`t6'" 8 "`t7'""
/*fin*/

capture drop xcoor ycoor
quietly{
/*calculo de numeros moleculares*/
capture drop nmsi nmti nmal nmfe nmmg nmmn nmca nmna nmk
gen nmsi=1000*si/60.08
gen nmti=1000*ti/79.9
gen nmal=1000*al/101.96
gen nmfe=1000*fe/71.85
gen nmmg=1000*mg/40.3
gen nmmn=1000*mn/70.94
gen nmca=1000*ca/56.08
gen nmna=1000*na/61.98
gen nmk=1000*k/94.2

/*calculo de los parametros de Borodin*/
gen xcoor=4*nmsi/(1.5*nmti+6*nmal+5*nmfe+5*nmmn+5.5*nmmg+5.5*nmca+17*nmna+19*nmk) /*Acidez (Ac)*/
gen ycoor=log10(2*(nmna+nmk)/nmca)
}/*del quietly*/



/*comprueba si los puntos estn dentro del rango de coordenadas*/ 
local n=_N
forvalues i=1(1)`n'{

				if xcoor[`i']<0.4  {
				display as error". sample " id[`i'] " has Ac < 0.4"
				quietly {
					replace type=. in `i'
						}
					}
				if xcoor[`i']>2 {
				display as error ". sample " id[`i'] " has Ac > 2"
				quietly {
					replace type=. in `i'
						}
					}
				if ycoor[`i']<-0.5 {
				display as error ". sample " id[`i'] " has log (Na+K)/Ca < -0.5"
				quietly {
					replace type=. in `i'
						}
					}
				if ycoor[`i']>2 {
				display as error ". sample " id[`i'] " has log (Na+K)/Ca > 2"
				quietly {
					replace type=. in `i'
						}
					}										
	} /*del for	*/
	
	
/*crea los puntos para dibujar la plantilla*/	
quietly{
local n=_N
local nn=`n'+8
set obs `nn'
local i= `n'+1
replace xcoor= 0.5 in `i'
replace ycoor= -0.4 in `i'
replace type=0 in `i'
local i= `n'+2
replace xcoor= 1.96 in `i'
replace ycoor= 0.74 in `i'
replace type=0 in `i'
local i= `n'+3
replace xcoor= 0.5 in `i'
replace ycoor=-0.4 in `i'
replace type=0 in `i'
local i= `n'+4
replace xcoor=1.96 in `i'
replace ycoor=1.66 in `i'
replace type=0 in `i'
local i= `n'+5
replace xcoor= 0.5 in `i'
replace ycoor= -0.4 in `i'
replace type=0 in `i'
local i= `n'+6
replace xcoor= 1.44 in `i'
replace ycoor= 1.96 in `i'
replace type=0 in `i'
local i= `n'+7
replace xcoor= 0.42 in `i'
replace ycoor= -0.25 in `i'
replace type=0 in `i'
local i= `n'+8
replace xcoor= 0.83 in `i'
replace ycoor= 1 in `i'
replace type=0 in `i'
}/*del quietly*/

/*escoge si proyecta identificadores de las muestras*/
if $ids== 0 { /*no identificadores*/
	twoway (scatter ycoor xcoor if type==0, msize(zero) mcolor(none)c(L)) (scatter ycoor xcoor if type==1, msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, msymbol($symbol7) msize($size7) mcolor($color7)), ytitle("log (Na+K/Ca)", size(vlarge)) ylabel(-0.5(0.5)2, angle("$y_orientation") format(%9.1f) labsize(large)) ymlabel(-0.5(0.1)2, nolabels) xtitle(Ac, size(vlarge)) xlabel(0.4(0.4)2, format(%9.1f) labsize(large)) xmlabel(0.4(0.1)2, nolabels) title(Borodin Plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(0.7 0.5 "Extr Alk", size(medlarge) orientation(vertical) color(gs12)) text(1.3 1 "Alk", size(medlarge) orientation(horizontal) color(gs12)) text(1.6 1.6 "Sub Alk", size(medlarge) color(gs12)) text(1.2 1.9 "Ca", size(medlarge) color(gs12)) text(0.2 1.8 "Th", size(medlarge) orientation(horizontal) color(gs12)) name("borodin_plot", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black))
	}
	else{
	twoway (scatter ycoor xcoor if type==0, msize(zero) mcolor(none)c(L)) (scatter ycoor xcoor if type==1, mlabel(id) mlabcolor(black) msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, mlabel(id) mlabcolor(black) msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, mlabel(id) mlabcolor(black) msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, mlabel(id) mlabcolor(black) msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, mlabel(id) mlabcolor(black) msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, mlabel(id) mlabcolor(black) msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, mlabel(id) mlabcolor(black) msymbol($symbol7) msize($size7) mcolor($color7)), ytitle("log (Na+K/Ca)", size(vlarge)) ylabel(-0.5(0.5)2, angle("$y_orientation") format(%9.1f) labsize(large)) ymlabel(-0.5(0.1)2, nolabels) xtitle(Ac, size(vlarge)) xlabel(0.4(0.4)2, format(%9.1f) labsize(large)) xmlabel(0.4(0.1)2, nolabels) title(Borodin Plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(0.7 0.5 "Extr Alk", size(medlarge) orientation(vertical) color(gs12)) text(1.3 1 "Alk", size(medlarge) orientation(horizontal) color(gs12)) text(1.6 1.6 "Sub Alk", size(medlarge) color(gs12)) text(1.2 1.9 "Ca", size(medlarge) color(gs12)) text(0.2 1.8 "Th", size(medlarge) orientation(horizontal) color(gs12)) name("labeled_borodin_plot", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black))
}/*del if*/

global is_changed=0/*xsize*/		

quietly{
	drop if type==0
	drop nmsi nmti nmal nmfe nmmg nmmn nmca nmna nmk
	drop xcoor ycoor
	drop type
	}
display
display as text ". Done borodin plot"

end
