program gq_cc_plot

version 10

if $is_changed==0 global a_xsize=6

display
display
display as text". CONTINENTAL CRUST-NORMALIZED PLOTS, by F. Bea (2007); v. 2.0"
display
display as text". Normalization values as recommended in GERM
display
display as text". DURING THE NORMALIZATION, THE ORIGINAL DATA ARE DESTROYED"
display as text". PLEASE INDICATE WHETHER YOU WANT TO SAVE THEM"
display as text". THE PROGRAM AUTOMATICALLY REVERTS TO THE LAST SAVED DATASET"
display
display as text". RUNNING INTRUCTIONS:"
display as text". 1.- Select the samples to be included in the same graph and press enter"
display as text". 2.- Write" as error" -out-" as text" to finish"
display as text". 3.- To interrupt de process for renaming graphs, etc. write"as error" -pause-"
display as text". 5.- then use the continue menu""
display


display as result". Are you sure that the ID contains no characters such as '-', white spaces, etc?"
display as result". If ID is not composed of just letters and numbers, abort the program and edit ID"
display


local id_good "junk"
capture confirm number `id_good' 
while _rc!=0{
			display as error". Shall I continue (1) or abort (2)? " _cont
			display _request(_id_good)
			capture confirm number `id_good'
			}
if `id_good'==1 {/*main loop*/
display


local cont "junk"
capture confirm number `cont' 
while _rc!=0{
			display as error". Save the data file as it is? (1-yes, 2-no) " _request(_cont)
			capture confirm number `cont'
			}
if `cont'==1  save, replace	
display

quietly{
local ns=_N
gen foryu=. /*dummy variable to mark the limit of deletion of old variables*/
/*creo nuevas variables*/
if `ns'<23{ /*por si el numero de observaciones es menor que el de variables*/
			set obs 23
			}
forvalues i=1(1)`ns' { /*1*/
	local newid=id[`i']
	gen `newid'=.
	if `i'==1 local vfirst `newid'
	if `i'==`ns' local vlast `newid'
}/*del forvalues 1*/
	
forvalues i=1(1)`ns' {	/*2*/
	forvalues j=1(1)`ns'{ /*2*/
		local newid=id[`j']
		capture confirm numeric variable cs
		if _rc==0 replace `newid'=cs[`j']/2.6 in 1
		capture confirm numeric variable rb
		if _rc==0 replace `newid'=rb[`j']/58 in 2
		capture confirm numeric variable pb
		if _rc==0 replace `newid'=pb[`j']/14.8 in 3
		capture confirm numeric variable th
		if _rc==0 replace `newid'=th[`j']/5.6 in 4
		capture confirm numeric variable u
		if _rc==0 replace `newid'=u[`j']/1.42 in 5
		capture confirm numeric variable nb
		if _rc==0 replace `newid'=nb[`j']/12 in 6
		capture confirm numeric variable ba
		if _rc==0 replace `newid'=ba[`j']/390 in 7
		capture confirm numeric variable la
		if _rc==0 replace `newid'=la[`j']/18 in 8
		capture confirm numeric variable ce
		if _rc==0 replace `newid'=ce[`j']/42 in 9
		capture confirm numeric variable nd
		if _rc==0 replace `newid'=nd[`j']/20 in 10
		capture confirm numeric variable zr
		if _rc==0 replace `newid'=zr[`j']/123 in 11
		capture confirm numeric variable sr
		if _rc==0 replace `newid'=sr[`j']/325 in 12
		capture confirm numeric variable li
		if _rc==0 replace `newid'=li[`j']/11 in 13
		capture confirm numeric variable sm
		if _rc==0 replace `newid'=sm[`j']/3.9 in 14
		capture confirm numeric variable eu
		if _rc==0 replace `newid'=eu[`j']/1.2 in 15
		capture confirm numeric variable gd
		if _rc==0 replace `newid'=gd[`j']/3.6 in 16
		capture confirm numeric variable dy
		if _rc==0 replace `newid'=dy[`j']/3.5 in 17
		capture confirm numeric variable y
		if _rc==0 replace `newid'=y[`j']/20 in 18
		capture confirm numeric variable ga
		if _rc==0 replace `newid'=ga[`j']/16 in 19
		capture confirm numeric variable er
		if _rc==0 replace `newid'=er[`j']/2.2 in 20
		capture confirm numeric variable yb
		if _rc==0 replace `newid'=yb[`j']/2 in 21
		capture confirm numeric variable v
		if _rc==0 replace `newid'=v[`j']/128 in 22
		capture confirm numeric variable sc
		if _rc==0 replace `newid'=sc[`j']/22 in 23

		
		
		}/* del forvalues 3*/
}/*del forvalues 2*/
gen el=_n
drop id-foryu
drop if el>23

capture label drop nombres
label define nombres  1 "Cs" 2 "Rb" 3 "Pb" 4 "Th" 5 "U" 6 "Nb" 7 "Ba" 8 "La" 9 "Ce" 10 "Nd" 11 "Zr" 12 "Sr" 13 "Li" 14 "Sm" 15 "Eu" 16 "Gd" 17 "Dy" 18 "Y" 19 "Ga" 20 "Er" 21 "Yb" 22 "V" 23 "Sc"
label values el nombres
}/*del quietly*/
/*seleccion de variables, "out" aborta el programa, "pause" lo para*/

local fin=0/*variable de control 1*/
local to_plot=""
while `fin'==0{/*1 loop principal*/
	
	local sample_id "junk"
	if "`sample_id '"=="out" {
		local fin=1
		}
	capture confirm numeric variable `sample_id'
	while _rc!=0 & `fin'==0 { /*2*/
		display as result". Sample to plot? (use the variables window) " _cont
		display _request(_sample_id )
		capture confirm numeric variable `sample_id'
		if _rc==0 {
			local to_plot="`to_plot'"+" "+"`sample_id '"
			}
		if "`sample_id '"=="out" | "`sample_id '"=="pause" {
				local fin=1
				}
		else{
		   if _rc==0{
			twoway (connected `to_plot' el), ytitle(rock/continental crust, size(vlarge)) yscale(log) yscale(titlegap(2)) yscale(range(0.05 30)) ylabel(0.1 1 10, angle("$y_orientation") labsize(large)) ymlabel(0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1 2 3 4 5 6 7 8 9 10 20,nolabels) xtitle("") xscale(range(1 14)) xlabel(1(1)14, valuelabel labsize(large) alternate) title(Continental Crust-normalized plot, size(large)) legend(on cols(1)) legend(position(3)) plotregion(lcolor(black)) xsize($a_xsize) ysize(4)	name("cc_plot", replace)	
			local to_plot=""
			display
			display as result "NEW ENTRY"
			display
			}/* del ultimo if*/
			}
	}/*del while 2*/		
}/*del while 1*/

if "`sample_id '"=="out" {
	local myfile=(c(filename))
	use "`myfile'", clear
	global is_changed=0/*xsize*/
	display
	display as text ". Done CC plot"
	}
	else
if "`sample_id '"=="pause" {
	display
	display as text". Paused CC plot; to resume use the menu"
	}
	}/*main loop*/
	else {
	display
	display as text". Program aborted by the user"
	}
end
