program gq_fdgra

version 10

if $is_changed==0 global a_xsize=5

display
display
display
display as text". TYPOLOGICAL DISCRIMINATION OF GRANITE ROCKS, by F. Bea (2008); v. 3.01"
display
display as text". THIS ROUTINE USES TWO EMPIRICAL DISCRIMINANT FUNCTIONS"
display as text ". CALCULATED FROM FOUR PARAMETERS: asi2, cai2, FE/FE+MG AND K/NA+K"
display as text ". ONE FUNCTION IS FOR GRANITOIDS WITH SiO2 IN THE RANGE 64-70 wt.%"
display as text ". THE OTHER IS FOR GRANITOIDS WITH SiO2 > 70 wt.%"

display					

/*calculo del numero de grupos y labels diferentes*/
quietly {
capture drop orden
gen orden=_n
sort label
capture drop type
gen type=.
replace type=1 in 1
local n=_N
local ng=1
local t1=label[1]
forvalues i=2(1)`n' {
				local c1=`i'-1
				replace type=`ng' in `i'
				if label[`i']!=label[`c1'] {
					local ng=`ng'+1
					local t`ng'= label[`i']
					replace type=`ng' in `i'
					}
				}	
replace type=6969 if label=="ZZ" /*exclusion del grupo labeled ZZ*/
local mute=0
forvalues i=2(1)`n' {
	if label[`i']=="ZZ" local mute=1
	}
if `mute'==1 local ng=`ng'-1				
sort orden
drop orden
}
/*fin*/

/*crea la leyenda*/
if `ng'==1 local leyenda "2 "`t1'""
if `ng'==2 local leyenda "2 "`t1'" 3 "`t2'""
if `ng'==3 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'""
if `ng'==4 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'""
if `ng'==5 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'" 6 "`t5'""
if `ng'==6 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'" 6 "`t5'" 7 "`t6'""
if `ng'==7 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'" 6 "`t5'" 7 "`t6'" 8 "`t7'""
/*fin*/


capture drop xcoor ycoor
quietly{
capture drop type_seg
gen type_seg=type
/*calculo de parametros*/
capture drop asi2 
capture femg2
capture cai2
capture kna2
gen asi2=(al/101.96)/(ca/56.08+na/61.98+k/94.2)
gen femg2=(fe/79.9)/(fe/79.9+mg/40.3)
gen cai2=(ca/56.08)/(ca/56.08+na/61.98+k/94.2)
gen kna2=(k/94.2)/(na/61.98+k/94.2)

/*calculo de funciones discriminantes*/
gen xcoor=10*(0.1601*asi2-0.0354*cai2+0.048*kna2-0.026*femg2)
gen ycoor=10*(0.0061*asi2-0.0434*cai2+0.0145*kna2+0.1236*femg2)
}/*del quietly*/


display""
display as text". Done FD SiO2>70 plot"
display""

/*comprueba si los puntos estn dentro del rango de coordenadas*/ 
local n=_N
forvalues i=1(1)`n'{
			if si[`i'] > 70 {

				if xcoor[`i']<1  {
				display as error ". sample " id[`i'] " has xcoor < 1"
				quietly {
					replace type=. in `i'
						}
					}
				if xcoor[`i']>3 {
				display as error ". sample " id[`i'] " has xcoor > 3"
				quietly {
					replace type=. in `i'
						}
					}
				if ycoor[`i']<0.5 {
				display as error ". sample " id[`i'] " has ycoor < 0.5"
				quietly {
					replace type=. in `i'
						}
					}
				if ycoor[`i']>1.5 {
				display as error ". sample " id[`i'] " has ycoor > 1.5"
				quietly {
					replace type=. in `i'
						}
					}
			} /*del if*/										
	} /*del for	*/
	
	
/*crea los puntos para dibujar la plantilla*/	
quietly{
local n=_N
local nn=`n'+16
set obs `nn'
local i= `n'+1
replace xcoor= 1.734779 in `i'
replace ycoor= 1.115 in `i'
replace type=0 in `i'
local i= `n'+2
replace xcoor= 2.9 in `i'
replace ycoor=1.16 in `i'
replace type=0 in `i'
local i= `n'+3
replace xcoor= 1.702904 in `i'
replace ycoor=1.08 in `i'
replace type=0 in `i'
local i= `n'+4
replace xcoor=1.81 in `i'
replace ycoor=0.6 in `i'
replace type=0 in `i'
local i= `n'+5
replace xcoor= 1.702904 in `i'
replace ycoor=1.08 in `i'
replace type=0 in `i'
local i= `n'+6
replace xcoor= 2.067185 in `i'
replace ycoor= 1.48 in `i'
replace type=0 in `i'
local i= `n'+7
replace xcoor=1.6 in `i'
replace ycoor=1.25 in `i'
replace type=0 in `i'
local i= `n'+8
replace xcoor= 1.935133 in `i'
replace ycoor=1.335 in `i'
replace type=0 in `i'
local i= `n'+9
replace xcoor= 1.49 in `i'
replace ycoor=1.045 in `i'
replace type=0 in `i'
local i= `n'+10
replace xcoor= 1.6 in `i'
replace ycoor=1.25 in `i'
replace type=0 in `i'
local i= `n'+11
replace xcoor= 1.49 in `i'
replace ycoor=1.045 in `i'
replace type=0 in `i'
local i= `n'+12
replace xcoor= 1.702904 in `i'
replace ycoor=1.08 in `i'
replace type=0 in `i'
local i= `n'+13
replace xcoor= 1.4 in `i'
replace ycoor=0.6 in `i'
replace type=0 in `i'
local i= `n'+14
replace xcoor= 1.49 in `i'
replace ycoor=1.045 in `i'
replace type=0 in `i'
local i= `n'+15
replace xcoor= 1.05 in `i'
replace ycoor=0.94 in `i'
replace type=0 in `i'
local i= `n'+16
replace xcoor= 1.49 in `i'
replace ycoor=1.045 in `i'
replace type=0 in `i'
}

/*escoge si proyecta identificadores de las muestras*/
if $ids== 0 { /*no identificadores*/
twoway (scatter ycoor xcoor if type==0, msize(zero) mcolor(none)c(L) lcolor(gs10)) (scatter ycoor xcoor if type==1 & si>=70, msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2 & si>=70, msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3 & si>=70, msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4 & si>=70, msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5 & si>=70, msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6 & si>=70, msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7 & si>=70, msymbol($symbol7) msize($size7) mcolor($color7)), ytitle(DF-2, size(vlarge)) ylabel(0.5(0.2)1.5, angle("$y_orientation") format(%9.1f) labsize(large)) ymlabel(0.5(0.1)1.5, nolabels) xtitle(DF-1, size(vlarge)) xlabel(1(0.5)3, format(%9.1f) labsize(large)) xmlabel(1(0.1)3, nolabels) title(DF for SiO2 >70%) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(0.7 1.2 "M-type", size(medlarge) orientation(vertical) color(gs12)) text(0.7 1.6 "I-type", size(medlarge) orientation(vertical) color(gs12)) text(0.9 2.5 "SC-type", size(medlarge) color(gs12)) text(1.3 2.5 "SG-type", size(medlarge) color(gs12)) text(1.3 1.2 "A-type", size(medlarge) orientation(vertical) color(gs12)) text(1.17 1.62 "undef.", size(medlarge) orientation(vertical) color(gs12)) name("DF70", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black))
}
else{
twoway (scatter ycoor xcoor if type==0, msize(zero) mcolor(none)c(L) lcolor(gs10)) (scatter ycoor xcoor if type==1 & si>=70, mlabel(id) mlabcolor(black) msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2 & si>=70, mlabel(id) mlabcolor(black) msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3 & si>=70, mlabel(id) mlabcolor(black) msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4 & si>=70, mlabel(id) mlabcolor(black) msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5 & si>=70, mlabel(id) mlabcolor(black) msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6 & si>=70, mlabel(id) mlabcolor(black) msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7 & si>=70, mlabel(id) mlabcolor(black) msymbol($symbol7) msize($size7) mcolor($color7)), ytitle(DF-2, size(vlarge)) ylabel(0.5(0.2)1.5, angle("$y_orientation") format(%9.1f) labsize(large)) ymlabel(0.5(0.1)1.5, nolabels) xtitle(DF-1, size(vlarge)) xlabel(1(0.5)3, format(%9.1f) labsize(large)) xmlabel(1(0.1)3, nolabels) title(DF for SiO2 >70%) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(0.7 1.2 "M-type", size(medlarge) orientation(vertical) color(gs12)) text(0.7 1.6 "I-type", size(medlarge) orientation(vertical) color(gs12)) text(0.9 2.5 "SC-type", size(medlarge) color(gs12)) text(1.3 2.5 "SG-type", size(medlarge) color(gs12)) text(1.3 1.2 "A-type", size(medlarge) orientation(vertical) color(gs12)) text(1.17 1.62 "undef.", size(medlarge) orientation(vertical) color(gs12)) name("DF70", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black))
}
quietly{
	drop if type==0
	drop xcoor ycoor
	}
	
	
/*para el segundo diagrama*/

quietly{

capture drop xcoor ycoor

/*calcula las funciones discriminantes*/
gen xcoor=10*(0.1099*asi2-0.085*cai2+0.0892*kna2+0.0127*femg2)
gen ycoor=10*(-0.0591*asi2-0.0533*cai2+0.0091*kna2+0.0906*femg2)
replace type=type_seg
}/*del quietly*/


display""
display as text". Done FD SiO2 64-70% Plot"
display""

/*excluye las muestras fuera de coordenadas*/
local n=_N
forvalues i=1(1)`n'{ 
	if si[`i'] >=64 & si<=70 {

				if xcoor[`i']<0.5 {
				display as error ". sample " id[`i'] " has xcoor < 0.5"
				quietly {
					replace type=. in `i'
						}
					}
				if xcoor[`i']>2.5 {
				display as error ". sample " id[`i'] " has xcoor > 2.5"
				quietly {
					replace type=. in `i'
						}
					}
				if ycoor[`i']<-0.5 {
				display as error ". sample " id[`i'] " has ycoor < -0.5"
				quietly {
					replace type=. in `i'
						}
					}
				if ycoor[`i']>0.5 {
				display as error ". sample " id[`i'] " has ycoor > 0.5"
				quietly {
					replace type=. in `i'
						}
					}
				}/*del if*/	
				else{
				if si[`i'] < 64{
				 display as error  ". sample " id[`i'] " has SiO2 < 63%"
				 quietly {
					replace type=. in `i'
						}
                  }
                 } 
					

														
	} /*del for	*/

/*calcula los puntos para proyectar la plantilla*/						
quietly{
local n=_N
local nn=`n'+14
set obs `nn'
local i= `n'+1
replace xcoor= 0.93 in `i'
replace ycoor= 0.155 in `i'
replace type=0 in `i'
local i= `n'+2
replace xcoor= 1.4 in `i'
replace ycoor=0.1065 in `i'
replace type=0 in `i'
local i= `n'+3
replace xcoor= 1.13 in `i'
replace ycoor= -0.08 in `i'
replace type=0 in `i'
local i= `n'+4
replace xcoor= 2.3 in `i'
replace ycoor=-0.14 in `i'
replace type=0 in `i'
local i= `n'+5
replace xcoor=1.09 in `i'
replace ycoor=-0.45 in `i'
replace type=0 in `i'
local i= `n'+6
replace xcoor= 1.32 in `i'
replace ycoor=-0.093 in `i'
replace type=0 in `i'
local i= `n'+7
replace xcoor= 1.26 in `i'
replace ycoor= -0.085 in `i'
replace type=0 in `i'
local i= `n'+8
replace xcoor=1.55 in `i'
replace ycoor=0.3 in `i'
replace type=0 in `i'
local i= `n'+9
replace xcoor=0.86 in `i'
replace ycoor=-0.4 in `i'
replace type=0 in `i'
local i= `n'+10
replace xcoor= 1.13 in `i'
replace ycoor=-0.08 in `i'
replace type=0 in `i'
local i= `n'+11
replace xcoor= 0.8 in `i'
replace ycoor=-0.155 in `i'
replace type=0 in `i'
local i= `n'+12
replace xcoor= 1.13 in `i'
replace ycoor=-0.08 in `i'
replace type=0 in `i'
local i= `n'+13
replace xcoor= 0.68 in `i'
replace ycoor=-0.2 in `i'
replace type=0 in `i'
local i= `n'+14
replace xcoor= 0.8 in `i'
replace ycoor= -0.155 in `i'
replace type=0 in `i'
} /*del quietly*/

/*escoge si proyecta identificadores de las muestras*/
if $ids==0 {/*no identificadores*/
twoway (scatter ycoor xcoor if type==0, msize(zero) mcolor(none)c(L) lcolor(gs10)) (scatter ycoor xcoor if type==1 & si>=64 & si <=70, msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2 & si>=64 & si <=70, msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3 & si>=64 & si <=70, msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4 & si>=64 & si <=70, msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5 & si>=64 & si <=70, msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6 & si>=64 & si <=70, msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7 & si>=64 & si <=70, msymbol($symbol7) msize($size7) mcolor($color7)), ytitle(DF-2, size(vlarge)) ylabel(-0.5(0.2)0.5, angle("$y_orientation") format(%9.1f) labsize(large)) ymlabel(-0.5(0.05)0.5, nolabels) xtitle(DF-1, size(vlarge)) xlabel(0.5(0.5)2.5, format(%9.1f) labsize(large)) xmlabel(0.5(0.1)2.5, nolabels) title(DF for SiO2 64-70%) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(-0.35 0.75 "M-type", size(medlarge) orientation(vertical) color(gs12)) text(-0.35 1 "I-type", size(medlarge) orientation(vertical) color(gs12)) text(-0.20 2 "SC-type", size(medlarge) color(gs12)) text(0 2. "SG-type", size(medlarge) color(gs12)) text(0 0.85 "A1-type", size(medlarge) color(gs12)) text(0.25 0.85 "A2-type", size(medlarge) color(gs12)) name("DF64", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black))
			}
		else {
		twoway (scatter ycoor xcoor if type==0, msize(zero) mcolor(none)c(L) lcolor(gs10)) (scatter ycoor xcoor if type==1 & si>=64 & si <=70, mlabel(id) mlabcolor(black) msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2 & si>=64 & si <=70, mlabel(id) mlabcolor(black) msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3 & si>=64 & si <=70, mlabel(id) mlabcolor(black) msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4 & si>=64 & si <=70, mlabel(id) mlabcolor(black) msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5 & si>=64 & si <=70, mlabel(id) mlabcolor(black) msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6 & si>=64 & si <=70, mlabel(id) mlabcolor(black) msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7 & si>=64 & si <=70, mlabel(id) mlabcolor(black) msymbol($symbol7) msize($size7) mcolor($color7)), ytitle(DF-2, size(vlarge)) ylabel(-0.5(0.2)0.5, angle("$y_orientation") format(%9.1f) labsize(large)) ymlabel(-0.5(0.05)0.5, nolabels) xtitle(DF-1, size(vlarge)) xlabel(0.5(0.5)2.5, format(%9.1f) labsize(large)) xmlabel(0.5(0.1)2.5, nolabels) title(DF for SiO2 64-70%) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(-0.35 0.75 "M-type", size(medlarge) orientation(vertical) color(gs12)) text(-0.35 1 "I-type", size(medlarge) orientation(vertical) color(gs12)) text(-0.20 2 "SC-type", size(medlarge) color(gs12)) text(0 2. "SG-type", size(medlarge) color(gs12)) text(0 0.85 "A1-type", size(medlarge) color(gs12)) text(0.25 0.85 "A2-type", size(medlarge) color(gs12)) name("DF64", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black))
		    }	
		    
global is_changed=0/*xsize*/		    
		    
quietly{
	drop if type==0
	drop asi2 
	drop femg2 
	drop cai2
	drop kna2
	drop xcoor ycoor
	replace type=type_seg
	drop type_seg type
	}

display as text ". Done FD plots"


end /*del programa*/
