program gq_frost_plot

version 10

if $is_changed==0 global a_xsize=5

display
display
display
display as text". FROST ET AL. (2001) PLOTS, by F. Bea (2008); v. 3.01"
display
				

//*calculo del numero de grupos y labels diferentes*/
quietly {
capture drop orden
gen orden=_n
sort label
capture drop type
gen type=.
replace type=1 in 1
local n=_N
local ng=1
local t1=label[1]
forvalues i=2(1)`n' {
				local c1=`i'-1
				replace type=`ng' in `i'
				if label[`i']!=label[`c1'] {
					local ng=`ng'+1
					local t`ng'= label[`i']
					replace type=`ng' in `i'
					}
				}	
replace type=99 if label=="ZZ" /*exclusion del grupo labeled ZZ*/
local mute=0
forvalues i=2(1)`n' {
	if label[`i']=="ZZ" local mute=1
	}
if `mute'==1 local ng=`ng'-1				
sort orden
drop orden
}
/*fin*/

/*crea la leyenda*/
if `ng'==1 local leyenda "2 "`t1'""
if `ng'==2 local leyenda "2 "`t1'" 3 "`t2'""
if `ng'==3 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'""
if `ng'==4 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'""
if `ng'==5 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'" 6 "`t5'""
if `ng'==6 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'" 6 "`t5'" 7 "`t6'""
if `ng'==7 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'" 6 "`t5'" 7 "`t6'" 8 "`t7'""
/*fin*/
capture drop xcoor ycoor

/*FeO/(FeO+MgO) PLOT*/

/*calculo de las coordenadas*/
quietly{
gen xcoor=si
gen ycoor=fe/(fe+mg)
}/*del quietly*/



/*comprueba si los puntos estn dentro del rango de coordenadas, vale para  todos*/ 
local n=_N
forvalues i=1(1)`n'{

				if xcoor[`i']<50  {
				display as error ". sample " id[`i'] " has SiO2 < 50"
				quietly {
					replace type=. in `i'
						}
					}
				if xcoor[`i']>78 {
				display as error ". sample " id[`i'] " has SiO2 > 78"
				quietly {
					replace type=. in `i'
						}
					}
														
	} /*del for	*/
	
	
/*crea los puntos para dibujar la plantilla*/	
quietly{
local n=_N
local nn=`n'+2
set obs `nn'
local i= `n'+1
replace xcoor= 50 in `i'
replace ycoor= 0.716 in `i'
replace type=0 in `i'
local i= `n'+2
replace xcoor= 77 in `i'
replace ycoor= 0.8402 in `i'
replace type=0 in `i'
}/*del quietly*/


/*escoge si proyecta identificadores de las muestras*/
if $ids== 0 { /*no identificadores*/
	twoway (line ycoor xcoor if type==0,lcolor(gs12) lwidth(thick) msymbol(none) mcolor(none))(scatter ycoor xcoor if type==1, msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, msymbol($symbol7) msize($size7) mcolor($color7)), ytitle(FeOt/(FeOt + MgO), size(vlarge)) ylabel(0.4(0.1)1, angle("$y_orientation") format(%9.1f) labsize(large)) ymlabel(0.4(0.05)1, nolabels) xtitle(SiO2, size(vlarge)) xlabel(50(5)80, format(%9.0f) labsize(large)) xmlabel(50(1)80, nolabels) title(Fe* Plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(0.9 55 "ferroan", size(vlarge) orientation(horizontal) color(gs8)) text(0.6 70 "magnesian", size(vlarge) orientation(horizontal) color(gs8)) name("FROST_plot_1", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black))
	}
	else{
	twoway (line ycoor xcoor if type==0,lcolor(gs12) lwidth(thick) msymbol(none) mcolor(none))(scatter ycoor xcoor if type==1, mlabel(id) mlabcolor(black) msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, mlabel(id) mlabcolor(black) msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, mlabel(id) mlabcolor(black) msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, mlabel(id) mlabcolor(black) msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, mlabel(id) mlabcolor(black) msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, mlabel(id) mlabcolor(black) msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, mlabel(id) mlabcolor(black) msymbol($symbol7) msize($size7) mcolor($color7)), ytitle(FeOt/(FeOt + MgO), size(vlarge)) ylabel(0.4(0.1)1, angle("$y_orientation") format(%9.1f) labsize(vlarge)) ymlabel(0.4(0.05)1, nolabels) xtitle(SiO2, size(vlarge)) xlabel(50(5)80, format(%9.0f) labsize(large)) xmlabel(50(1)80, nolabels) title(Fe* Plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(0.9 55 "ferroan", size(vlarge) orientation(horizontal) color(gs8)) text(0.6 70 "magnesian", size(vlarge) orientation(horizontal) color(gs8)) name("labeled_FROST_plot_1", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black))
	}

	
quietly{
	drop if type==0
	drop xcoor ycoor
	drop if type==0 | type==100
	}

/*MASI plot*/

/*calculo de las coordenadas*/
quietly{
gen xcoor=si
gen ycoor=na+k-ca
}/*del quietly*/


/*crea la leyenda*/
if `ng'==1 local leyenda "4 "`t1'""
if `ng'==2 local leyenda "4 "`t1'" 5 "`t2'""
if `ng'==3 local leyenda "4 "`t1'" 5 "`t2'" 6 "`t3'""
if `ng'==4 local leyenda "4 "`t1'" 5 "`t2'" 6 "`t3'" 7 "`t4'""
if `ng'==5 local leyenda "4 "`t1'" 5 "`t2'" 6 "`t3'" 7 "`t4'" 8 "`t5'""
if `ng'==6 local leyenda "4 "`t1'" 5 "`t2'" 6 "`t3'" 7 "`t4'" 8 "`t5'" 9 "`t6'""
if `ng'==7 local leyenda "4 "`t1'" 5 "`t2'" 6 "`t3'" 7 "`t4'" 8 "`t5'" 9 "`t6'" 10 "`t7'""
/*fin*/
	
/*crea los puntos para dibujar la plantilla*/	
quietly{
local n=_N
local nn=`n'+12
set obs `nn'
local i= `n'+1
replace xcoor= 50 in `i'
replace ycoor= -5.82 in `i'
replace type=100 in `i'
local i= `n'+2
replace xcoor= 60 in `i'
replace ycoor= -0.474 in `i'
replace type=100 in `i'
local i= `n'+3
replace xcoor= 70 in `i'
replace ycoor= 4.018 in `i'
replace type=100 in `i'
local i= `n'+4
replace xcoor= 77 in `i'
replace ycoor= 6.654 in `i'
replace type=100 in `i'
local i= `n'+5
replace xcoor= 50 in `i'
replace ycoor= -3.195 in `i'
replace type=101 in `i'
local i= `n'+6
replace xcoor= 60 in `i'
replace ycoor= 1.948 in `i'
replace type=101 in `i'
local i= `n'+7
replace xcoor= 70 in `i'
replace ycoor= 6.037 in `i'
replace type=101 in `i'
local i= `n'+8
replace xcoor= 77 in `i'
replace ycoor= 8.272 in `i'
replace type=101 in `i'
local i= `n'+9
replace xcoor= 50 in `i'
replace ycoor= -0.56 in `i'
replace type=102 in `i'
local i= `n'+10
replace xcoor= 60 in `i'
replace ycoor= 4.268 in `i'
replace type=102 in `i'
local i= `n'+11
replace xcoor= 70 in `i'
replace ycoor= 7.952 in `i'
replace type=102 in `i'
local i= `n'+12
replace xcoor= 77 in `i'
replace ycoor= 9.85 in `i'
replace type=102 in `i'
}/*del quietly*/

/*escoge si proyecta identificadores de las muestras*/
if $ids== 0 { /*no identificadores*/
	twoway(qfit ycoor xcoor if type==100, msymbol(none)lcolor(gs12) lwidth(thick))(qfit ycoor xcoor if type==101, msymbol(none)lcolor(gs12) lwidth(thick) )(qfit ycoor xcoor if type==102, msymbol(none)lcolor(gs12) lwidth(thick))(scatter ycoor xcoor if type==1, msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, msymbol($symbol7) msize($size7) mcolor($color7)), ytitle(Na2O+K2O-CaO, size(vlarge)) ylabel(-8(4)12, angle("$y_orientation") format(%9.0f) labsize(large)) ymlabel(-8(1)12, nolabels) xtitle(SiO2, size(vlarge)) xlabel(50(5)80, format(%9.0f) labsize(large)) xmlabel(50(1)80, nolabels) title(MALI Plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(4 55 "A", size(vlarge) orientation(horizontal) color(gs8)) text(0.9 55 "A-C", size(vlarge) orientation(horizontal) color(gs8)) text(-1.5 55 "C-A", size(vlarge) orientation(horizontal) color(gs8)) text(-7 55 "C", size(vlarge) orientation(horizontal) color(gs8)) name("FROST_plot_2", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black))
	}
	else{
	twoway (qfit ycoor xcoor if type==100, msymbol(none)lcolor(gs12) lwidth(thick))(qfit ycoor xcoor if type==101, msymbol(none)lcolor(gs12) lwidth(thick) )(qfit ycoor xcoor if type==102, msymbol(none)lcolor(gs12) lwidth(thick))(scatter ycoor xcoor if type==1, mlabel(id) mlabcolor(black) msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, mlabel(id) mlabcolor(black) msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, mlabel(id) mlabcolor(black) msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, mlabel(id) mlabcolor(black) msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, mlabel(id) mlabcolor(black) msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, mlabel(id) mlabcolor(black) msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, mlabel(id) mlabcolor(black) msymbol($symbol7) msize($size7) mcolor($color7)), ytitle(Na2O+K2O-CaO, size(vlarge)) ylabel(-8(4)12, angle("$y_orientation") format(%9.0f) labsize(large)) ymlabel(-8(1)12, nolabels) xtitle(SiO2, size(vlarge)) xlabel(50(5)80, format(%9.0f) labsize(large)) xmlabel(50(1)80, nolabels) title(MASI Plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(4 55 "A", size(vlarge) orientation(horizontal) color(gs8)) text(0.9 55 "A-C", size(vlarge) orientation(horizontal) color(gs8)) text(-1.5 55 "C-A", size(vlarge) orientation(horizontal) color(gs8)) text(-7 55 "C", size(vlarge) orientation(horizontal) color(gs8)) name("labeled_FROST_plot_2", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black))
	}
	
global is_changed=0/*xsize*/	

quietly{
replace type=1 if type==.	
drop if type>99 | type==0
drop type xcoor ycoor
}

display as text". Done FROST plots"
end

