program gq_nmorb_plot

version 10

if $is_changed==0 global a_xsize=7


display
display
display as text". N MORB-NORMALIZED PLOTS, by F. Bea (2008); v. 3.01"
display
display as text". Normalization values from Hofmann (1988)"
display
display as text". DURING THE NORMALIZATION, THE ORIGINAL DATA ARE DESTROYED"
display as text". PLEASE INDICATE WHETHER YOU WANT TO SAVE THEM"
display as text". THE PROGRAM AUTOMATICALLY REVERTS TO THE LAST SAVED DATASET"
display
display as text". RUNNING INTRUCTIONS:"
display as text". 1.- Select the samples to be included in the same graph and press enter"
display as text". 2.- Type" as error" -out-" as text" to finish"
display as text". 3.- To interrupt de process for renaming graphs, etc. write"as error" -pause-"
display as text". 5.- To continue type" as error" -resume-"
display


display as result". Are you sure that the ID contains no characters such as '-', white spaces, etc?"
display as result". If ID is not composed of just letters and numbers, abort the program and edit ID"
display

if $legend==1 {
	local legend "legend(on cols(1)) legend(position(3))"
	}
	else{
	local legend "legend (off)"
	}


local id_good "junk"
capture confirm number `id_good' 
while _rc!=0{
			display as error". Shall I continue (1) or abort (2)? " _cont
			display _request(_id_good)
			capture confirm number `id_good'
			}
if `id_good'==1 {/*main loop*/
display

local cont "junk"
capture confirm number `cont' 
while _rc!=0{
			display as error". Save the data file as it is? (1-yes, 2-no) " _request(_cont)
			capture confirm number `cont'
			}
if `cont'==1  save, replace	
display

quietly{
local ns=_N
gen foryu=. /*dummy variable to mark the limit of deletion of old variables*/
/*creo nuevas variables*/
if `ns'<22{ /*por si el numero de observaciones es menor que el de variables*/
			set obs 22
			}
forvalues i=1(1)`ns' { /*1*/
	local newid=id[`i']
	gen `newid'=.
	if `i'==1 local vfirst `newid'
	if `i'==`ns' local vlast `newid'
}/*del forvalues 1*/
	
forvalues i=1(1)`ns' {	/*2*/
	forvalues j=1(1)`ns'{ /*2*/
		local newid=id[`j']
		capture confirm numeric variable cs
		if _rc==0 replace `newid'=cs[`j']/0.0141 in 1
		capture confirm numeric variable rb
		if _rc==0 replace `newid'=rb[`j']/1.262 in 2
		capture confirm numeric variable ba
		if _rc==0 replace `newid'=ba[`j']/13.87 in 3
		capture confirm numeric variable th
		if _rc==0 replace `newid'=th[`j']/0.1871 in 4
		capture confirm numeric variable u
		if _rc==0 replace `newid'=u[`j']/0.0711 in 5
		capture confirm numeric variable nb
		if _rc==0 replace `newid'=nb[`j']/3.507 in 6
		capture confirm numeric variable k
		if _rc==0 replace `newid'=k[`j']/0.0311 in 7
		capture confirm numeric variable la
		if _rc==0 replace `newid'=la[`j']/3.895 in 8
		capture confirm numeric variable pb
		if _rc==0 replace `newid'=pb[`j']/0.489 in 9
		capture confirm numeric variable ce
		if _rc==0 replace `newid'=ce[`j']/12.001 in 10
		capture confirm numeric variable sr
		if _rc==0 replace `newid'=sr[`j']/113.2 in 11
		capture confirm numeric variable nd
		if _rc==0 replace `newid'=nd[`j']/11.179 in 12
		capture confirm numeric variable sm
		if _rc==0 replace `newid'=sm[`j']/3.752 in 13
		capture confirm numeric variable zr
		if _rc==0 replace `newid'=zr[`j']/104.2 in 14
		capture confirm numeric variable eu
		if _rc==0 replace `newid'=eu[`j']/1.335 in 15
		capture confirm numeric variable ti
		if _rc==0 replace `newid'=ti[`j']/1.615 in 16
		capture confirm numeric variable gd
		if _rc==0 replace `newid'=gd[`j']/5.077 in 17
		capture confirm numeric variable tb
		if _rc==0 replace `newid'=tb[`j']/0.885 in 18
		capture confirm numeric variable dy
		if _rc==0 replace `newid'=dy[`j']/6.304 in 19
		capture confirm numeric variable y
		if _rc==0 replace `newid'=y[`j']/35.82 in 20
		capture confirm numeric variable er
		if _rc==0 replace `newid'=er[`j']/4.143 in 21
		capture confirm numeric variable yb
		if _rc==0 replace `newid'=yb[`j']/3.9 in 22
	
		
		}/* del forvalues 3*/
}/*del forvalues 2*/
gen el=_n
drop id-foryu
drop if el>22

capture label drop nombres
label define nombres 1 "Cs" 2 "Rb" 3 "Ba" 4 "Th" 5 "U" 6 "Nb" 7 "K" 8 "La" 9 "Pb" 10 "Ce" 11 "Sr" 12 "Nd" 13 "Sm" 14 "Zr" 15 "Eu" 16 "Ti" 17 "Gd" 18 "Tb" 19 "Dy" 20 "Y" 21 "Er" 22 "Yb"
label values el nombres
}/*del quietly*/
/*seleccion de variables, "out" aborta el programa, "pause" lo para*/

local fin=0/*variable de control 1*/
local to_plot=""
while `fin'==0{/*1 loop principal*/

		local sample_id "junk"
		if "`sample_id '"=="out" | "`sample_id '"=="pause" {
			local fin=1
			}

	capture confirm numeric variable `sample_id'
	while _rc!=0 & `fin'==0 { /*2*/
		display as result". Sample to plot? (use the variables window) " _cont
		display _request(_sample_id )
		capture confirm numeric variable `sample_id'
		if _rc==0 {
			local to_plot="`to_plot'"+" "+"`sample_id '"
			}
		if "`sample_id '"=="out" | "`sample_id '"=="pause" {
			local fin=1
		}
		else{
		if _rc==0 {
			twoway (connected `to_plot' el), ytitle(rock/N-MORB, size(vlarge)) yscale(log) yscale(titlegap(2)) yscale(range(0.1 100)) ylabel(0.1 1 10 100, labsize(large)) ymtick(0.1(0.1)1 1(1)10 10(10)100) xtitle("") xlabel(1(1)22, valuelabel labsize(large) alternate) title(NMORB-normalized plot, size(large)) `legend' plotregion(lcolor(black)) xsize($a_xsize) ysize(4) name("nmorb_plot", replace)	
			local to_plot=""
			display
			display as result "NEW ENTRY"
			display
			}/*del ultimo if*/
			}
	}/*del while 2*/		
}/*del while 1*/

if "`sample_id '"=="out" {
	local myfile=(c(filename))
	use "`myfile'", clear
	global is_changed=0/*xsize*/
	display
	display as text". Done N-MORB plot"
	}
	else
if "`sample_id '"=="pause" {
	display
	display as text". Paused N-MORB plot; to resume type" as error" -resume-"
	global resume="gq_nmorb2_plot"
	}
	}/*main loop*/
	else {
	display
	display as text". Program aborted by the user"
	}
end
