program gq_peacok

version 10

if $is_changed==0 global a_xsize=5

display
display
display
display as text". PEACOK PLOT, by F. Bea (2008); v. 3.01"
display
display as text". THIS IS USEFUL FOR ESTIMATING THE ALKALINITY OF A ROCK SERIES"
display

/*calculo del numero de grupos y labels diferentes*/
quietly {
capture drop orden
gen orden=_n
sort label
capture drop type
gen type=.
replace type=1 in 1
local n=_N
local ng=1
local t1=label[1]
forvalues i=2(1)`n' {
				local c1=`i'-1
				replace type=`ng' in `i'
				if label[`i']!=label[`c1'] {
					local ng=`ng'+1
					local t`ng'= label[`i']
					replace type=`ng' in `i'
					}
				}	
replace type=6969 if label=="ZZ" /*exclusion del grupo labeled ZZ*/
local mute=0
forvalues i=2(1)`n' {
	if label[`i']=="ZZ" local mute=1
	}
if `mute'==1 local ng=`ng'-1				
sort orden
drop orden
}
/*fin*/

/*crea la leyenda*/
if `ng'==1 local leyenda "2 "`t1'""
if `ng'==2 local leyenda "2 "`t1'" 3 "`t2'""
if `ng'==3 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'""
if `ng'==4 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'""
if `ng'==5 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'" 6 "`t5'""
if `ng'==6 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'" 6 "`t5'" 7 "`t6'""
if `ng'==7 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'" 6 "`t5'" 7 "`t6'" 8 "`t7'""
/*fin*/

capture drop xcoor ycoor
quietly{
/*calculo de numeros moleculares*/

/*calculo de las coordenadas*/
gen xcoor=si
gen ycoor=log10(ca/(na+k))
}/*del quietly*/



/*comprueba si los puntos estn dentro del rango de coordenadas*/ 
local n=_N
forvalues i=1(1)`n'{

				if xcoor[`i']<40  {
				display as error ". sample " id[`i'] " SiO2 < 40"
				quietly {
					replace type=. in `i'
						}
					}
				if xcoor[`i']>80 {
				display as error ". sample " id[`i'] " has SiO2 > 80"
				quietly {
					replace type=. in `i'
						}
					}
				if ycoor[`i']<-2 {
				display as error ". sample " id[`i'] " has log Ca/(Na+K) < -2"
				quietly {
					replace type=. in `i'
						}
					}
				if ycoor[`i']>2 {
				display as error ". sample " id[`i'] " has log Ca/(Na+K) > 2"
				quietly {
					replace type=. in `i'
						}
					}										
	} /*del for	*/
	
	
/*crea los puntos para dibujar la plantilla*/	
quietly{
local n=_N
local nn=`n'+6
set obs `nn'
local i= `n'+1
replace xcoor= 61 in `i'
replace ycoor= -2 in `i'
replace type=0 in `i'
local i= `n'+2
replace xcoor= 61 in `i'
replace ycoor= 0 in `i'
replace type=0 in `i'
local i= `n'+3
replace xcoor= 56 in `i'
replace ycoor=-2 in `i'
replace type=0 in `i'
local i= `n'+4
replace xcoor=56 in `i'
replace ycoor=0 in `i'
replace type=0 in `i'
local i= `n'+5
replace xcoor= 51 in `i'
replace ycoor= -2 in `i'
replace type=0 in `i'
local i= `n'+6
replace xcoor= 51 in `i'
replace ycoor= 0 in `i'
replace type=0 in `i'
}/*del quietly*/

/*escoge si proyecta identificadores de las muestras*/

if $ids== 0 { /*no identificadores*/
	twoway (scatter ycoor xcoor if type==0, msize(zero) mcolor(none)c(L) lcolor(gs12)) (scatter ycoor xcoor if type==1, msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, msymbol($symbol7) msize($size7) mcolor($color7)), ytitle("log CaO(Na2O+K2O)", size(vlarge)) ylabel(-2(1)2, angle("$y_orientation") format(%9.0f) labsize(large)) ymlabel(-2(0.5)2, nolabels) yline(0, lcolor(gs12)) xtitle(SiO2, size(vlarge)) xlabel(40(5)80, format(%9.0f) labsize(large)) xmlabel(40(1)80, nolabels) title(Peacok Plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(-1.5 45 "Alkaline", size(medlarge) orientation(vertical) color(gs12)) text(-1.2 54 "Alkaline-calcic", size(medlarge) orientation(vertical) color(gs12)) text(-1.26 58 "Calc-alkaline", size(medlarge) orientation(vertical) color(gs12)) text(-1.61 64 "Calcic", size(medlarge) orientation(vertical) color(gs12)) name("peacok_plot", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black))
	}
	else{
	twoway (scatter ycoor xcoor if type==0, msize(zero) mcolor(none)c(L)lcolor(gs12)) (scatter ycoor xcoor if type==1, mlabel(id) mlabcolor(black) msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, mlabel(id) mlabcolor(black) msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, mlabel(id) mlabcolor(black) msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, mlabel(id) mlabcolor(black) msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, mlabel(id) mlabcolor(black) msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, mlabel(id) mlabcolor(black) msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, mlabel(id) mlabcolor(black) msymbol($symbol7) msize($size7) mcolor($color7)),  ytitle("log CaO(Na2O+K2O)", size(vlarge)) ylabel(-2(1)2, angle("$y_orientation") format(%9.0f) labsize(large)) ymlabel(-2(0.5)2, nolabels) yline(0, lcolor(gs12)) xtitle(SiO2, size(vlarge)) xlabel(40(5)80, format(%9.0f) labsize(arge)) xmlabel(40(1)80, nolabels) title(Peacok Plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(-1.5 45 "Alkaline", size(medlarge) orientation(vertical) color(gs12)) text(-1.2 54 "Alkaline-calcic", size(medlarge) orientation(vertical) color(gs12)) text(-1.26 58 "Calc-alkaline", size(medlarge) orientation(vertical) color(gs12)) text(-1.61 64 "Calcic", size(medlarge) orientation(vertical) color(gs12)) name("labeled_peacok_plot", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black))
}/*del if*/

global is_changed=0/*xsize*/

quietly{
	drop if type==0
	drop xcoor ycoor
	drop type
	}
display
display as text ". Done Peacok plot"

end
