program gq_ree_plot

version 10

if $is_changed==0 global a_xsize=6


display
display
display as text". CHONDRITE-NORMALIZED PLOTS, by F. Bea (2008); v. 3.01"
display
display as text". Normalization values from McDonougth & Sun (1995)"
display
display as text". DURING THE NORMALIZATION, THE ORIGINAL DATA ARE DESTROYED"
display as text". PLEASE INDICATE WHETHER YOU WANT TO SAVE THEM"
display as text". THE PROGRAM AUTOMATICALLY REVERTS TO THE LAST SAVED DATASET"
display
display as text". RUNNING INTRUCTIONS:"
display as text". 1.- Select the samples to be included in the same graph and press enter"
display as text". 2.- Type" as error" -out-" as text" to finish"
display as text". 3.- To interrupt de process for renaming graphs, etc. write"as error" -pause-"
display as text". 5.- To continue type" as error" -resume-"
display
display

if $legend==1 {
	local legend "legend(on cols(1)) legend(position(3))"
	}
	else{
	local legend "legend (off)"
	}

display as result". Are you sure that the ID contains no characters such as '-', white spaces, etc?"
display as result". If ID is not composed of just letters and numbers, abort the program and edit ID"
display


local id_good "junk"
capture confirm number `id_good' 
while _rc!=0{
			display as error". Shall I continue (1) or abort (2)? " _cont
			display _request(_id_good)
			capture confirm number `id_good'
			}
if `id_good'==1 {/*main loop*/
display

local cont "junk"
capture confirm number `cont' 
while _rc!=0{
			display as error ". Save the data file as it is? (1-yes, 2-no) " _cont
			display _request(_cont)
			capture confirm number `cont'
			}
if `cont'==1  save, replace	

display

quietly{
local ns=_N
gen foryu=. /*dummy variable to mark the limit of deletion of old variables*/
/*creo nuevas variables*/
if `ns'<15{ /*por si el numero de observaciones es menor que el de variables*/
			set obs 15
			}
forvalues i=1(1)`ns' { /*1*/
	local newid=id[`i']
	gen `newid'=.
	if `i'==1 local vfirst `newid'
	if `i'==`ns' local vlast `newid'
}/*del forvalues 1*/
	
forvalues i=1(1)`ns' {	/*2*/
	forvalues j=1(1)`ns'{ /*2*/
		local newid=id[`j']
		capture confirm numeric variable la
		if _rc==0 replace `newid'=la[`j']/0.237 in 1
		capture confirm numeric variable ce
		if _rc==0 replace `newid'=ce[`j']/0.613 in 2
		capture confirm numeric variable pr
		if _rc==0 replace `newid'=pr[`j']/0.0928 in 3
		capture confirm numeric variable nd
		if _rc==0 replace `newid'=nd[`j']/0.457 in 4
		capture confirm numeric variable sm
		if _rc==0 replace `newid'=sm[`j']/0.148 in 6
		capture confirm numeric variable eu
		if _rc==0 replace `newid'=eu[`j']/0.0563 in 7
		capture confirm numeric variable gd
		if _rc==0 replace `newid'=gd[`j']/0.199 in 8
		capture confirm numeric variable tb
		if _rc==0 replace `newid'=tb[`j']/0.0361 in 9
		capture confirm numeric variable dy
		if _rc==0 replace `newid'=dy[`j']/0.246 in 10
		capture confirm numeric variable ho
		if _rc==0 replace `newid'=ho[`j']/0.0546 in 11
		capture confirm numeric variable er
		if _rc==0 replace `newid'=er[`j']/0.16 in 12
		capture confirm numeric variable tm
		if _rc==0 replace `newid'=tm[`j']/0.0247 in 13
		capture confirm numeric variable yb
		if _rc==0 replace `newid'=yb[`j']/0.161 in 14
		capture confirm numeric variable lu
		if _rc==0 replace `newid'=lu[`j']/0.0246 in 15
		}/* del forvalues 3*/
}/*del forvalues 2*/
gen el=_n
drop id-foryu
drop if el>15

capture label drop nombres
label define nombres 1 "La" 2 "Ce" 3 "Pr" 4 "Nd" 6 "Sm" 7 "Eu" 8 "Gd" 9 "Tb" 10 "Dy" 11 "Ho" 12 "Er" 13 "Tm" 14 "Yb" 15 "Lu"
label values el nombres
}/*del quietly*/
/*seleccion de variables, "out" aborta el programa, "pause" lo para conservando los datos*/

local fin=0/*variable de control 1*/
local to_plot=""
while `fin'==0{/*1 loop principal*/

	local sample_id "junk"
	if "`sample_id '"=="out" | "`sample_id '"=="pause" {
		local fin=1
		}

	capture confirm numeric variable `sample_id'
	while _rc!=0 & `fin'==0 { /*2*/
		display as result". Sample to plot? (use the variables window) " _request(_sample_id )
		capture confirm numeric variable `sample_id'
		if _rc==0 {
			local to_plot="`to_plot'"+" "+"`sample_id '"
			}
		if "`sample_id '"=="out" | "`sample_id '"=="pause" {
				local fin=1
				}
				else {
				if _rc==0{
				twoway (connected `to_plot' el), ytitle(rock/chondrite, size(vlarge)) yscale(log) yscale(titlegap(2)) ylabel(1 10 100 1000, labsize(large)) ymtick(1(1)10 20(10)100 200(100)1000) xtitle("") xlabel(1(1)4 6(1)15, valuelabel labsize(large) alternate) ysize(4) xsize($a_xsize) title(Chondrite-normalized REE plot, size(large)) `legend' plotregion(lcolor(black)) name("ree_plot", replace)		
				local to_plot=""
				display
				display as result "NEW ENTRY"
				display
				}/*del ultimo if*/
				}
		}/*del while 2*/		
}/*del while 1*/

display""

if "`sample_id '"=="out" {
	local myfile=(c(filename))
	use "`myfile'", clear
	global is_changed=0/*xsize*/
	display
	display as text". Done REE plot"
	}
	else
if "`sample_id '"=="pause" {
	display
	display as text". Paused REE plot; to resume type" as error" -resume-"
	global resume="gq_ree2_plot"
	}
	}/*main loop*/
	else {
	display
	display as text". Program aborted by the user"
	}
end
