program gq_siliearth_red_plot

version 10

if $is_changed==0 global a_xsize=6


display
display
display as text". SILICATE EARTH-NORMALIZED PLOTS (REDUCED), by F. Bea (2008); v. 3.01"
display
display as text". Normalization values from McDonougth & Sun (1995)"
display
display as text". DURING THE NORMALIZATION, THE ORIGINAL DATA ARE DESTROYED"
display as text". PLEASE INDICATE WHETHER YOU WANT TO SAVE THEM"
display as text". THE PROGRAM AUTOMATICALLY REVERTS TO THE LAST SAVED DATASET"
display
display as text". RUNNING INTRUCTIONS:"
display as text". 1.- Select the samples to be included in the same graph and press enter"
display as text". 2.- Type" as error" -out-" as text" to finish"
display as text". 3.- To interrupt de process for renaming graphs, etc. write"as error" -pause-"
display as text". 5.- To continue type" as error" -resume-"
display
display

display as result". Are you sure that the ID contains no characters such as '-', white spaces, etc?"
display as result". If ID is not composed of just letters and numbers, abort the program and edit ID"
display


if $legend==1 {
	local legend "legend(on cols(1)) legend(position(3))"
	}
	else{
	local legend "legend (off)"
	}


local id_good "junk"
capture confirm number `id_good' 
while _rc!=0{
			display as error". Shall I continue (1) or abort (2)? " _cont
			display _request(_id_good)
			capture confirm number `id_good'
			}
if `id_good'==1 {/*main loop*/
display

local cont "junk"
capture confirm number `cont' 
while _rc!=0{
			display as error ". Save the data file as it is? (1-yes, 2-no) " _request(_cont)
			capture confirm number `cont'
			}
if `cont'==1  save, replace	
display

quietly{
local ns=_N
gen foryu=. /*dummy variable to mark the limit of deletion of old variables*/
/*creo nuevas variables*/
if `ns'<25{ /*por si el numero de observaciones es menor que el de variables*/
			set obs 22
			}
forvalues i=1(1)`ns' { /*1*/
	local newid=id[`i']
	gen `newid'=.
	if `i'==1 local vfirst `newid'
	if `i'==`ns' local vlast `newid'
}/*del forvalues 1*/
	
forvalues i=1(1)`ns' {	/*2*/
	forvalues j=1(1)`ns'{ /*2*/
		local newid=id[`j']
		capture confirm numeric variable rb
		if _rc==0 replace `newid'=rb[`j']/0.6 in 1
		capture confirm numeric variable ba
		if _rc==0 replace `newid'=ba[`j']/6.6 in 2
		capture confirm numeric variable th
		if _rc==0 replace `newid'=th[`j']/0.0795 in 3
		capture confirm numeric variable u
		if _rc==0 replace `newid'=u[`j']/0.0203 in 4
		capture confirm numeric variable nb
		if _rc==0 replace `newid'=nb[`j']/0.658 in 5
		capture confirm numeric variable la
		if _rc==0 replace `newid'=la[`j']/0.648 in 6
		capture confirm numeric variable ce
		if _rc==0 replace `newid'=ce[`j']/1.675 in 7
		capture confirm numeric variable pr
		if _rc==0 replace `newid'=pr[`j']/0.254 in 8
		capture confirm numeric variable nd
		if _rc==0 replace `newid'=nd[`j']/1.25 in 9
		capture confirm numeric variable sr
		if _rc==0 replace `newid'=sr[`j']/19.9 in 10
		capture confirm numeric variable sm
		if _rc==0 replace `newid'=sm[`j']/0.406 in 11
		capture confirm numeric variable zr
		if _rc==0 replace `newid'=zr[`j']/10.5 in 12
		capture confirm numeric variable eu
		if _rc==0 replace `newid'=eu[`j']/0.154 in 13
		capture confirm numeric variable gd
		if _rc==0 replace `newid'=gd[`j']/0.544 in 14
		capture confirm numeric variable tb
		if _rc==0 replace `newid'=tb[`j']/0.099 in 15
		capture confirm numeric variable dy
		if _rc==0 replace `newid'=dy[`j']/0.674 in 16
		capture confirm numeric variable ho
		if _rc==0 replace `newid'=ho[`j']/0.149 in 17
		capture confirm numeric variable y
		if _rc==0 replace `newid'=y[`j']/4.3 in 18
		capture confirm numeric variable er
		if _rc==0 replace `newid'=er[`j']/0.438 in 19
		capture confirm numeric variable tm
		if _rc==0 replace `newid'=tm[`j']/0.068 in 20
		capture confirm numeric variable yb
		if _rc==0 replace `newid'=yb[`j']/0.441 in 21
		capture confirm numeric variable lu
		if _rc==0 replace `newid'=lu[`j']/0.0675 in 22
		
		
		}/* del forvalues 3*/
}/*del forvalues 2*/
gen el=_n
drop id-foryu
drop if el>22

capture label drop nombres
label define nombres  1 "Rb" 2 "Ba" 3 "Th" 4 "U" 5 "Nb" 6 "La" 7 "Ce" 8 "Pr" 9 "Nd" 10 "Sr" 11 "Sm" 12 "Zr" 13 "Eu" 14 "Gd" 15 "Tb" 16 "Dy" 17 "Ho" 18 "Y" 19 "Er" 20 "Tm" 21 "Yb" 22 "Lu"
label values el nombres
}/*del quietly*/
/*seleccion de variables, "out" aborta el programa, "pause" lo para*/

local fin=0/*variable de control 1*/
local to_plot=""
while `fin'==0{/*1 loop principal*/
	
	local sample_id "junk"
	if "`sample_id '"=="out" | "`sample_id '"=="pause" {
		local fin=1
		}

	capture confirm numeric variable `sample_id'
	while _rc!=0 & `fin'==0  { /*2*/
		display as result". Sample to plot? (use the variables window) "_cont
		display _request(_sample_id )
		capture confirm numeric variable `sample_id'
		if _rc==0 {
			local to_plot="`to_plot'"+" "+"`sample_id '"
			}
		if "`sample_id '"=="out" | "`sample_id '"=="pause" {
		local fin=1
		}
		else {
		if _rc==0{
			twoway (connected `to_plot' el), ytitle(rock/Silicate Earth, size(vlarge)) yscale(log) yscale(titlegap(2)) yscale(range(0.1 1000)) ylabel(0.1 1 10 100 1000, labsize(large)) xtitle("") xlabel(1(1)22, valuelabel labsize(large) alternate) title(Reduced Silicate Earth-normalized plot , size(large)) `legend' plotregion(lcolor(black)) xsize($a_xsize) ysize(4) name("silicate_earth_plot2", replace)	
			local to_plot=""
			display
			display as result"NEW ENTRY"
			display
			}/*del ultimo if*/
			}
		}/*del while 2*/	
}/*del while 1*/

if "`sample_id '"=="out" {
	local myfile=(c(filename))
	use "`myfile'", clear
		global is_changed=0/*xsize*/
	display
	display as text". Done Silicate-Earth plot"
	}
	else
if "`sample_id '"=="pause" {
	display
	display as text". Paused Silicate_Earth plot; to resume type" as error" -resume-"
	global resume="gq_siliearth2_red_plot"
	}
	}/*main loop*/
	else {
	display
	display as text". Program aborted by the user"
	}
end
