program gq_whalen_eby_plot

version 10

if $is_changed==0 global a_xsize=5

display
display
display as text". WHALEN ET AL. (1987) AND EBY (1992) PLOTS, by F. Bea (2009); v. 3.01"
display
				

//*calculo del numero de grupos y labels diferentes*/
quietly {
capture drop orden
gen orden=_n
sort label
capture drop type
gen type=.
replace type=1 in 1
local n=_N
local ng=1
local t1=label[1]
forvalues i=2(1)`n' {
				local c1=`i'-1
				replace type=`ng' in `i'
				if label[`i']!=label[`c1'] {
					local ng=`ng'+1
					local t`ng'= label[`i']
					replace type=`ng' in `i'
					}
				}	
replace type=99 if label=="ZZ" /*exclusion del grupo labeled ZZ*/
local mute=0
forvalues i=2(1)`n' {
	if label[`i']=="ZZ" local mute=1
	}
if `mute'==1 local ng=`ng'-1				
sort orden
drop orden
}
/*fin*/

/*crea la leyenda*/
if `ng'==1 local leyenda "2 "`t1'""
if `ng'==2 local leyenda "2 "`t1'" 3 "`t2'""
if `ng'==3 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'""
if `ng'==4 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'""
if `ng'==5 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'" 6 "`t5'""
if `ng'==6 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'" 6 "`t5'" 7 "`t6'""
if `ng'==7 local leyenda "2 "`t1'" 3 "`t2'" 4 "`t3'" 5 "`t4'" 6 "`t5'" 7 "`t6'" 8 "`t7'""
/*fin*/
capture drop xcoor ycoor

/*WHALEN PLOT 1*/

/*calculo de las coordenadas*/
quietly{
gen xcoor=ga/(al*0.55293)
replace xcoor=. if xcoor==0
gen ycoor=nb
}/*del quietly*/



	
	
/*crea los puntos para dibujar la plantilla*/	
quietly{
local n=_N
local nn=`n'+3
set obs `nn'
local i= `n'+1
replace xcoor= 1 in `i'
replace ycoor= 20 in `i'
replace type=0 in `i'
local i= `n'+2
replace xcoor= 2.5 in `i'
replace ycoor= 20 in `i'
replace type=0 in `i'
local i= `n'+3
replace xcoor= 2.5 in `i'
replace ycoor= 1 in `i'
replace type=0 in `i'
}/*del quietly*/


/*escoge si proyecta identificadores de las muestras*/
if $ids== 0 { /*no identificadores*/
	twoway (line ycoor xcoor if type==0,lcolor(gs12) lwidth(thick) msymbol(none) mcolor(none))(scatter ycoor xcoor if type==1, msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, msymbol($symbol7) msize($size7) mcolor($color7)), ytitle(Nb, size(vlarge)) yscale(log) ylabel(1 10 100 1000, nogrid angle("$y_orientation") format(%9.1f) labsize(large)) ymlabel(1(1)10 10(10)100 100(100)1000, nolabels) xtitle(10000Ga/Al, size(vlarge)) xscale(log) xlabel(1 10, nogrid format(%9.0f) labsize(large)) xmlabel(1(1)10 15, nolabels) title(Whalen-1 Plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(8 1.5 "I & S", size(vlarge) orientation(horizontal) color(gs8)) text(500 10 "A", size(vlarge) orientation(horizontal) color(gs8)) name("WHALEN_plot_1", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black)) plotregion(margin(zero))
	}
	else{
	twoway (line ycoor xcoor if type==0,lcolor(gs12) lwidth(thick) msymbol(none) mcolor(none))(scatter ycoor xcoor if type==1, mlabel(id) mlabcolor(black) msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, mlabel(id) mlabcolor(black) msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, mlabel(id) mlabcolor(black) msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, mlabel(id) mlabcolor(black) msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, mlabel(id) mlabcolor(black) msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, mlabel(id) mlabcolor(black) msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, mlabel(id) mlabcolor(black) msymbol($symbol7) msize($size7) mcolor($color7)), ytitle(Nb, size(vlarge)) yscale(log) ylabel(1 10 100 1000, nogrid angle("$y_orientation") format(%9.1f) labsize(large)) ymlabel(1(1)10 10(10)100 100(100)1000, nolabels) xtitle(10000Ga/Al, size(vlarge)) xscale(log) xlabel(1 10, nogrid format(%9.0f) labsize(large)) xmlabel(1(1)10 15, nolabels) title(Whalen-1 Plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(8 1.5 "I & S", size(vlarge) orientation(horizontal) color(gs8)) text(500 10 "A", size(vlarge) orientation(horizontal) color(gs8)) name("labeled_WHALEN_plot_1", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black)) plotregion(margin(zero))
	}/*del primer plot*/
	
quietly{
	drop if type==0 | type==100
	}

/*WHALEN PLOT 2*/

/*calculo de las coordenadas*/
quietly{
replace ycoor=zr
}/*del quietly*/



	
	
/*crea los puntos para dibujar la plantilla*/	
quietly{
local n=_N
local nn=`n'+3
set obs `nn'
local i= `n'+1
replace xcoor= 1 in `i'
replace ycoor= 250 in `i'
replace type=0 in `i'
local i= `n'+2
replace xcoor= 2.5 in `i'
replace ycoor= 250 in `i'
replace type=0 in `i'
local i= `n'+3
replace xcoor= 2.5 in `i'
replace ycoor= 42 in `i'
replace type=0 in `i'
}/*del quietly*/


/*escoge si proyecta identificadores de las muestras*/
if $ids== 0 { /*no identificadores*/
	twoway (line ycoor xcoor if type==0,lcolor(gs12) lwidth(thick) msymbol(none) mcolor(none))(scatter ycoor xcoor if type==1, msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, msymbol($symbol7) msize($size7) mcolor($color7)), ytitle(Zr, size(vlarge)) yscale(log) ylabel(100 1000, nogrid angle("$y_orientation") format(%9.1f) labsize(large)) ymlabel(50(10)100 100(100)1000 2000(1000)5000, nolabels) xtitle(10000Ga/Al, size(vlarge)) xscale(log) xlabel(1 10, nogrid format(%9.0f) labsize(large)) xmlabel(1(1)10 15, nolabels) title(Whalen-2 Plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(200 1.5 "I & S", size(vlarge) orientation(horizontal) color(gs8)) text(2000 10 "A", size(vlarge) orientation(horizontal) color(gs8)) name("WHALEN_plot_2", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black)) plotregion(margin(zero))
	}
	else{
	twoway (line ycoor xcoor if type==0,lcolor(gs12) lwidth(thick) msymbol(none) mcolor(none))(scatter ycoor xcoor if type==1, mlabel(id) mlabcolor(black) msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, mlabel(id) mlabcolor(black) msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, mlabel(id) mlabcolor(black) msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, mlabel(id) mlabcolor(black) msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, mlabel(id) mlabcolor(black) msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, mlabel(id) mlabcolor(black) msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, mlabel(id) mlabcolor(black) msymbol($symbol7) msize($size7) mcolor($color7)), ytitle(Zr, size(vlarge)) yscale(log) ylabel(100 1000, nogrid angle("$y_orientation") format(%9.1f) labsize(large)) ymlabel(50(10)100 100(100)1000 2000(1000)5000, nolabels) xtitle(10000Ga/Al, size(vlarge)) xscale(log) xlabel(1 10, nogrid format(%9.0f) labsize(large)) xmlabel(1(1)10 15, nolabels) title(Whalen-2 Plot) legend(cols(1) order("`leyenda'")) legend(position(3) span) fysize(100) fxsize(150) text(200 1.5 "I & S", size(vlarge) orientation(horizontal) color(gs8)) text(2000 10 "A", size(vlarge) orientation(horizontal) color(gs8)) name("labeled_FROST_plot_2", replace) ysize(4) xsize($a_xsize) plotregion(lcolor(black)) plotregion(margin(zero))
	}/*del primer plot*/
	
quietly{
	drop if type==0
	drop ycoor xcoor
	drop if type==0 | type==100
	}


/*EBY plot*/

/*calculo de las coordenadas*/
quietly{
gen ycoor=zr
}/*del quietly*/


/*crea la leyenda*/
if `ng'==1 local leyenda "6 "`t1'""
if `ng'==2 local leyenda "6 "`t1'" 7 "`t2'""
if `ng'==3 local leyenda "6 "`t1'" 7 "`t2'" 8 "`t3'""
if `ng'==4 local leyenda "6 "`t1'" 7 "`t2'" 8 "`t3'" 9 "`t4'""
if `ng'==5 local leyenda "6 "`t1'" 7 "`t2'" 8 "`t3'" 9 "`t4'" 10 "`t5'""
if `ng'==6 local leyenda "6 "`t1'" 7 "`t2'" 8 "`t3'" 9 "`t4'" 10 "`t5'" 11 "`t6'""
if `ng'==7 local leyenda "6 "`t1'" 7 "`t2'" 8 "`t3'" 9 "`t4'" 10 "`t5'" 11 "`t6'" 12 "`t7'""
/*fin*/
	
	
	
	
	/*creo las coordenadas de los puntos*/

	local leftcoor y
	local uppercoor nb
	local rightcoor ce
	
	/*creo las coordenadas de la divisoria*/
	quietly{
	display _N
	local nobs=_N
	local newobs=`nobs' + 2
	set obs `newobs'
	display `nobs'
	local i=`nobs' + 1
	display `i'
	replace y=50 in `i'
	replace nb=50 in `i'
	replace ce=0 in `i'
	replace type=0 in `i'
	local i=`nobs' + 2
	replace y=0 in `i'
	replace nb=0 in `i'
	replace ce=20 in `i'
	replace type=0 in `i'
	capture drop xcoor
	capture drop ycoor
	}/*del quietly*/

	quietly{
	gen x_a=100*(0.5-`leftcoor'/(`leftcoor'+`rightcoor'))
	gen ycoor=86.6*`uppercoor'/(`uppercoor'+`leftcoor'+`rightcoor')
	gen xcoor=50+x_a-(x_a*ycoor/86.6)
	
	
	/* creo las coordenadas del dibujo*/
	local nobs=_N
	local newobs=`nobs' + 35
	set obs `newobs'
	gen labelpunto=""
	gen controlpunto=.
	
	/*punto1*/
	local i= `nobs' + 1
	local begindelete=  `nobs' + 1
	replace xcoor=0 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=10 in `i'
	/*punto2*/
	local i= `nobs' + 2
	replace xcoor=100 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=10 in `i'
	/*punto3*/
	local i= `nobs' + 3
	replace xcoor=50 in `i'
	replace ycoor=86.6 in `i'
	replace controlpunto=10 in `i'
	/*punto4*/
	local i= `nobs' + 4
	replace xcoor=0 in `i' 
	replace ycoor=0 in `i'
	replace controlpunto=10 in `i'
	/*punto5*/
	local i= `nobs' + 5
	replace xcoor=0 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="100" in `i' 
	/*punto6*/
	local i= `nobs' + 6
	replace xcoor=10 in `i' 
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i' 
	replace labelpunto="90" in `i'
	/*punto7*/
	local i= `nobs' + 7
	replace xcoor=20 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="80" in `i'
	/*punto8*/
	local i= `nobs' + 8
	replace xcoor=30 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="70" in `i'
	/*punto9*/
	local i= `nobs' + 9
	replace xcoor=40 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="60" in `i'
	/*punto10*/
	local i= `nobs' + 10
	replace xcoor=50 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="50" in `i'
	/*punto11*/
	local i= `nobs' + 11
	replace xcoor=60 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="40" in `i'
	/*punto12*/
	local i= `nobs' + 12
	replace xcoor=70 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="30" in `i'
	/*punto13*/
	local i= `nobs' + 13
	replace xcoor=80 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="20" in `i'
	/*punto14*/
	local i= `nobs' + 14
	replace xcoor=90 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="10" in `i'
	/*punto15*/
	local i= `nobs' + 15
	replace xcoor=100 in `i'
	replace ycoor=0 in `i'
	replace controlpunto=9 in `i'
	replace labelpunto="0" in `i'
	/*punto16*/
	local i= `nobs' + 16
	replace xcoor=5 in `i'
	replace ycoor=8.66 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="10" in `i'
	/*punto17*/
	local i= `nobs' + 17
	replace xcoor=10 in `i'
	replace ycoor=17.32 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="20" in `i'
	/*punto18*/
	local i= `nobs' + 18
	replace xcoor=15 in `i'
	replace ycoor=25.98 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="30" in `i'
	/*punto19*/
	local i= `nobs' + 19
	replace xcoor=20 in `i'
	replace ycoor=34.64 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="40" in `i'
	/*punto20*/
	local i= `nobs' + 20
	replace xcoor=25 in `i'
	replace ycoor=43.3 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="50" in `i'
	/*punto21*/
	local i= `nobs' + 21
	replace xcoor=30 in `i'
	replace ycoor=51.86 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="60" in `i'
	/*punto22*/
	local i= `nobs' + 22
	replace xcoor=35 in `i'
	replace ycoor=60.622 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="70" in `i'
	/*punto23*/
	local i= `nobs' + 23
	replace xcoor=40 in `i'
	replace ycoor=69.282 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="80" in `i'
	/*punto24*/
	local i= `nobs' + 24
	replace xcoor=45 in `i'
	replace ycoor=77.9422 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="90" in `i'
	/*punto25*/
	local i= `nobs' + 25
	replace xcoor=49.9 in `i'
	replace ycoor=86.6 in `i'
	replace controlpunto=8 in `i'
	replace labelpunto="100" in `i'
	/*punto26*/
	local i= `nobs' + 26
	replace xcoor=95 in `i'
	replace ycoor=8.66 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="90" in `i'
	/*punto27*/
	local i= `nobs' + 27
	replace xcoor=90 in `i'
	replace ycoor=17.32 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="80" in `i'
	/*punto28*/
	local i= `nobs' + 28
	replace xcoor=85 in `i'
	replace ycoor=25.98 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="70" in `i'
	/*punto29*/
	local i= `nobs' + 29
	replace xcoor=80 in `i'
	replace ycoor=34.64 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="60" in `i'
	/*punto30*/
	local i= `nobs' + 30
	replace xcoor=75 in `i'
	replace ycoor=43.3 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="50" in `i'
	/*punto31*/
	local i= `nobs' + 31
	replace xcoor=70 in `i'
	replace ycoor=51.86 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="40" in `i'
	/*punto32*/
	local i= `nobs' + 32
	replace xcoor=65 in `i'
	replace ycoor=60.622 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="30" in `i'
	/*punto33*/
	local i= `nobs' + 33
	replace xcoor=60 in `i'
	replace ycoor=69.282 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="20" in `i'
	/*punto34*/
	local i= `nobs' + 34
	replace xcoor=55 in `i'
	replace ycoor=77.94 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="10" in `i'
	/*punto35*/
	local i= `nobs' + 35
	replace xcoor=50 in `i'
	replace ycoor=86.6 in `i'
	replace controlpunto=7 in `i'
	replace labelpunto="0" in `i'
	
	} /*del quietly*/
	
	
/*escoge si proyecta identificadores de las muestras*/

	if $ids== 0 { /*no identificadores*/
		twoway (connected ycoor xcoor if controlpunto==10, msymbol(none) lcolor(black)) (scatter ycoor xcoor if controlpunto==9, msymbol(circle) mcolor(black) msize(tiny) mlabel(labelpunto) mlabcolor(black) mlabposition(6)) (scatter ycoor xcoor if controlpunto==8, msymbol(circle) mcolor(black) msize(tiny) mlabel(labelpunto) mlabcolor(black) mlabposition(10))(scatter ycoor xcoor if controlpunto==7, msymbol(circle) mcolor(black) msize(tiny) mlabel(labelpunto) mlabcolor(black) mlabposition(2)) (line ycoor xcoor if type==0, lcolor(black)) (scatter ycoor xcoor if type==1, msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, msymbol($symbol7) msize($size7) mcolor($color7)), yscale(range(-10 110) off) xscale(range(-10 110) off) ysize(6) xsize(6) graphregion(margin(large)) text(-8 0 "Y") text(4 103 "Ce") text(95 49 "Nb") text(45 35 "A1") text(35 30 "A2") title(Eby plot) legend(cols(1) order("`leyenda'")) legend(position(2) ring(0)) fysize(100) fxsize(150)  name("EBY_plot", replace) plotregion(lcolor(black))
		}
	else{
		twoway (connected ycoor xcoor if controlpunto==10, msymbol(none) lcolor(black)) (scatter ycoor xcoor if controlpunto==9, msymbol(circle) mcolor(black) msize(tiny) mlabel(labelpunto) mlabcolor(black) mlabposition(6)) (scatter ycoor xcoor if controlpunto==8, msymbol(circle) mcolor(black) msize(tiny) mlabel(labelpunto) mlabcolor(black) mlabposition(10))(scatter ycoor xcoor if controlpunto==7, msymbol(circle) mcolor(black) msize(tiny) mlabel(labelpunto) mlabcolor(black) mlabposition(2)) (line ycoor xcoor if type==0,lcolor(black)) (scatter ycoor xcoor if type==1, mlabel(id) mlabcolor(black) msymbol($symbol1) msize($size1) mcolor($color1)) (scatter ycoor xcoor if type==2, mlabel(id) mlabcolor(black) msymbol($symbol2) msize($size2) mcolor($color2))(scatter ycoor xcoor if type==3, mlabel(id) mlabcolor(black) msymbol($symbol3) msize($size3) mcolor($color3))(scatter ycoor xcoor if type==4, mlabel(id) mlabcolor(black) msymbol($symbol4) msize($size4) mcolor($color4))(scatter ycoor xcoor if type==5, mlabel(id) mlabcolor(black) msymbol($symbol5) msize($size5) mcolor($color5)) (scatter ycoor xcoor if type==6, mlabel(id) mlabcolor(black) msymbol($symbol6) msize($size6) mcolor($color6)) (scatter ycoor xcoor if type==7, mlabel(id) mlabcolor(black) msymbol($symbol7) msize($size7) mcolor($color7)), yscale(range(-10 110) off) xscale(range(-10 110) off) ysize(6) xsize(6) graphregion(margin(large)) text(-8 0 "Y") text(4 103 "Ce") text(95 49 "Nb") text(45 35 "A1") text(35 30 "A2") title(Eby plot) legend(cols(1) order("`leyenda'")) legend(position(2) ring(0)) fysize(100) fxsize(150)  name("labeled_EBY_plot", replace) plotregion(lcolor(black))
		}
		local leftcoor "junk"
		local rightcoor "junk"
		local uppercoor "junk"
		quietly{
		drop x_a controlpunto
		drop in `begindelete'/`newobs'
			}
	
global is_changed=0/*xsize*/	

quietly{
replace type=1 if type==.	
drop if type>99 | type==0
capture drop type 
capture drop xcoor
capture drop ycoor
capture drop labelpunto
}

display as text". Done WHALEN-EBY plots"
end

